package controllers

import (
	"net/http"
	"os"

	"github.com/gin-gonic/gin"
	"github.com/go-redis/redis"
)

// GET /health
// Returns the health status of the application
func GetHealth(c *gin.Context) {
	// TODO: Consider adding health checks to services this app relies on like queue and the database.

	// Get the health status from redis
	const redisAddr = "queue-redis-master:6379"
	client := redis.NewClient(&redis.Options{
		Addr:     redisAddr,
		Password: os.Getenv("REDIS_PASSWORD"),
	})
	queueHealthOK, err := client.Get("queueHealthOK").Result()
	if err != nil || queueHealthOK == "false" {
		// Send our response
		c.String(http.StatusInternalServerError, "err")
	} else {
		// Send our response
		c.String(http.StatusOK, "ok")
	}
}
