package tasks

import (
	"testing"

	models "code.locsi.com/locsi/api/models"
)

type expectedPodcastSeriesResult struct {
	value   models.PodcastSeries
	isValid bool
}

type PodcastSeriesTest struct {
	ID             int
	expectedResult expectedPodcastSeriesResult
}

func validatePodSeries(podSeries models.PodcastSeries, tt PodcastSeriesTest, t *testing.T) {
	if podSeries.WebFeed != tt.expectedResult.value.WebFeed {
		t.Errorf("for %d, field WebFeed: got %v, want %v", tt.ID, podSeries.WebFeed, tt.expectedResult.value.WebFeed)
	}
	if podSeries.Name != tt.expectedResult.value.Name {
		t.Errorf("for %d, field Name: got %v, want %v", tt.ID, podSeries.Name, tt.expectedResult.value.Name)
	}
	if podSeries.URL != tt.expectedResult.value.URL {
		t.Errorf("for %d, field URL: got %v, want %v", tt.ID, podSeries.URL, tt.expectedResult.value.URL)
	}
	if podSeries.Explicit != tt.expectedResult.value.Explicit {
		t.Errorf("for %d, field Explicit: got %v, want %v", tt.ID, podSeries.Explicit, tt.expectedResult.value.Explicit)
	}
	if podSeries.ImageURL != tt.expectedResult.value.ImageURL {
		t.Errorf("for %d, field ImageURL: got %v, want %v", tt.ID, podSeries.ImageURL, tt.expectedResult.value.ImageURL)
	}
	if podSeries.ITunesType != tt.expectedResult.value.ITunesType {
		t.Errorf("for %d, field ITunesType: got %v, want %v", tt.ID, podSeries.ITunesType, tt.expectedResult.value.ITunesType)
	}
	if podSeries.InLanguage != tt.expectedResult.value.InLanguage {
		t.Errorf("for %d, field InLanguage: got %v, want %v", tt.ID, podSeries.InLanguage, tt.expectedResult.value.InLanguage)
	}
	if podSeries.GUID != tt.expectedResult.value.GUID {
		t.Errorf("for %d, field GUID: got %v, want %v", tt.ID, podSeries.GUID, tt.expectedResult.value.GUID)
	}
	if podSeries.Description != tt.expectedResult.value.Description {
		t.Errorf("for %d, field Description: got %v, want %v", tt.ID, podSeries.Description, tt.expectedResult.value.Description)
	}
	if podSeries.WebSubHub != tt.expectedResult.value.WebSubHub {
		t.Errorf("for %d, field WebSubHub: got %v, want %v", tt.ID, podSeries.WebSubHub, tt.expectedResult.value.WebSubHub)
	}
	if podSeries.WebSubSelf != tt.expectedResult.value.WebSubSelf {
		t.Errorf("for %d, field WebSubSelf: got %v, want %v", tt.ID, podSeries.WebSubSelf, tt.expectedResult.value.WebSubSelf)
	}
	if !EqualArray(podSeries.Categories, tt.expectedResult.value.Categories) {
		t.Errorf("for %d, field Categories: got %v, want %v", tt.ID, podSeries.Categories, tt.expectedResult.value.Categories)
	}
}

func EqualArray(a, b []models.Categories) bool {
	if len(a) != len(b) {
		return false
	}
	for i, v := range a {
		if v != b[i] {
			return false
		}
	}
	return true
}
